#pragma rtGlobals=1		// Use modern global access method.Menu "Macros"	"Stern-Volmer Plot fitten", MakeSternVolmerFit()End|***Anfitten zweierlei Stern-Volmer Fits zu Stern-Volmer Plot***| Thomas Roth, 24/3/1999, erweitert 27/4/00// Die verwendeten Funktionen zum Anfitten der DatenFunction SingleSternVolmerPlot(w, x)	wave w; variable x	return 1 + w[0]*xendFunction DoubleSternVolmerPlot(w, x)	wave w; variable x	return ((abs(w[1])/(1 + w[0]*x) + abs(1-w[1])/(1 + w[2]*x))^-1)endFunction ExpDistSternVolmerPlot(w, x)	wave w; variable x	// w[0] = Exponentialfaktor, w[1] = Verschiebung	variable fIntegral, ObereGrenze, UntereGrenze		ObereGrenze = 5/w[0]	UntereGrenze = 0		Make /O/N=1001 KSV, f, Integrand	SetScale/I x UntereGrenze, ObereGrenze,"", f, Integrand	KSV = UntereGrenze + ((ObereGrenze-UntereGrenze)/1000)*p		// Begrenzung w[0]	if ( w[0] < 0)		w[0] = -w[0]	endif		f = exp(-KSV*w[0] )		// Normalisierung von f auf Integral 1	fIntegral = area(f, 0, inf)	f = f / fIntegral		Integrand = f/(1+KSV*x)	return  1/(area(Integrand, -Inf, Inf))endFunction NormalDistSternVolmerPlot(w, x)	wave w; variable x	// w[0] = Ksvquer, w[1] = Halbwertsbreite der Verteilung	variable fIntegral, ObereGrenze, UntereGrenze		ObereGrenze = w[0] + 5*w[1]	UntereGrenze = w[0] - 5*w[1]		// keine negativen Ksv-Werte zulassen	if( UntereGrenze <= 0)		UntereGrenze = 0	endif		Make /O/N=1001 KSV, f, Integrand	SetScale/I x UntereGrenze, ObereGrenze,"", f, Integrand	KSV = UntereGrenze + ((ObereGrenze-UntereGrenze)/1000)*p		// Begrenzung w[0]	if ( w[0] < 0)		w[0] = -w[0]	endif	// Begrenzung w[1]	if ( w[1] < 0)		w[1] = -w[1]	endif	// Begrenzung w[2]	if ( w[2] < 0)		w[2] = -w[2]	endif		f = exp(-((KSV-w[0])/ w[1])^2 )		// Normalisierung von f auf Integral 1//	fIntegral = sqrt(Pi/w[1]) - w[2] Integral von -inf bis +inf !	fIntegral = area(f, 0, inf) - w[2]	f = f / fIntegral		Integrand = f/(1+KSV*x)	return ( 1/(area(Integrand, -Inf, Inf) + w[2]) )endFunction LogNormalDistSternVolmerPlot(w, x)	wave w; variable x	// w[0] = Ksvquer, w[1] = Halbwertsbreite der Verteilung	variable fIntegral, ObereGrenze, UntereGrenze		// Begrenzung w[1]	if ( w[1] < 0)		w[1] = -w[1]	endif	ObereGrenze = w[0] + 5*w[1]	UntereGrenze = w[0] - 5*w[1]		Make /O/N=1001 KSV, f, Integrand	SetScale/I x UntereGrenze, ObereGrenze,"", f, Integrand	KSV = UntereGrenze + ((ObereGrenze-UntereGrenze)/1000)*p		f = exp(-KSV)*exp(-((KSV-w[0])/ w[1])^2 )		// Normalisierung von f auf Integral 1	KSV = exp(KSV)	// Achtung, gefaehrlich!	fIntegral= AreaXY(KSV,f,0,inf)	f = f / fIntegral		Integrand = f/(1+KSV*x)	return ( 1/area(Integrand, 0, Inf) )endFunction GammaDistSternVolmerPlot(w, x)	wave w; variable x	// w[0] = eta, w[1] = Halbwertsbreite der Verteilung	variable fIntegral, ObereGrenze, UntereGrenze		ObereGrenze = w[0] + 10*w[1]	UntereGrenze = 0		// keine negativen Ksv-Werte zulassen	if( UntereGrenze <= 0)		UntereGrenze = 0	endif		Make /O/N=1001 KSV, f, Integrand	SetScale/I x UntereGrenze, ObereGrenze,"", f, Integrand	KSV = UntereGrenze + ((ObereGrenze-UntereGrenze)/1000)*p		// Begrenzung w[0]	if ( w[0] < 1)		w[0] = 2-w[0]	endif	// Begrenzung w[1]	if ( w[1] < 0)		w[1] = -w[1]	endif	// Begrenzung w[2]	if ( w[2] < 0)		w[2] = -w[2]	endif		f = ((KSV/w[1])^(w[0]-1))*exp(-KSV/ w[1] )		// Normalisierung von f auf Integral 1	fIntegral = area(f, 0, inf)	f = f / fIntegral		Integrand = f/(1+KSV*x)	return ( 1/(area(Integrand, 0, Inf) ))endFunction MaxBoltzDistSternVolmerPlot(w, x)	wave w; variable x	// w[0] = m/kT	variable k = 1.38066e-23, fIntegral, ObereGrenze, UntereGrenze		ObereGrenze = 5*sqrt(1/w[0])	UntereGrenze = 0		Make /O/N=1001 KSV, f, Integrand	SetScale/I x UntereGrenze, ObereGrenze,"", f, Integrand	KSV = UntereGrenze + ((ObereGrenze-UntereGrenze)/1000)*p		// Begrenzung w[0]	if ( w[0] < 0)		w[0] = -w[0]	endif	f = 4*Pi*( (w[0]/Pi)^(3/2) )*((KSV)^2)*exp(-(w[0]*(KSV)^2) )		// Normalisierung von f auf Integral 1	fIntegral = area(f, 0, inf)	f = f / fIntegral		Integrand = f/(1+KSV*x)	return ( 1/(area(Integrand, -Inf, Inf)) )end| Programm zum Anfitten eines Ein- und Zweikomponentenmodells| es werden alle Datenpte angefittet!Macro MakeSternVolmerFit()  string YWave=CsrWave(A), XWave=CsrXWave(A)  string Text = "", FitWave, Fit1Wave, Fit2Wave, Fit3Wave    if(!cmpstr(YWave, ""))  	abort "Cursor A must be on wave to be fitted"  endif    FitWave = "fit_" + YWave  Fit1Wave = "fit1_" + YWave  Fit2Wave = "fit2_" + YWave  Fit3Wave = "fit3_" + YWave    // Erstellen Logtabellenwellen    if(!exists("NameSVFit"))  	string Graphtitel	Graphtitel = "Resultate der Stern-Volmer Fits"	Make/T /N=0 NameSVFit	Make/N=0 P_KSV, E_KSV, P_F1,  E_F1, P_KSV1, E_KSV1, P_F2, E_F2, P_KSV2, E_KSV2, P_KSVG, E_KSVG, P_GW, E_GW, P_F0,  E_F0	Edit NameSVFit, P_KSV, E_KSV, P_F1,  E_F1, P_KSV1, E_KSV1, P_F2, E_F2, P_KSV2, E_KSV2, P_KSVG, E_KSVG, P_GW, E_GW, P_F0,  E_F0  as Graphtitel  else  	// aus Gruenden der Rueckwaertskompatibilitaet so geloest       if(!exists("P_KSVG"))       	Make/N=(numpnts(NameSVFit)) P_KSVG, E_KSVG, P_GW, E_GW, P_F0,  E_F0       	P_KSVG = NaN; E_KSVG = NaN; P_GW = NaN; E_GW = NaN; P_F0 = NaN;  E_F0 = NaN       	print "Wellen fuer Gaussverteilungsmodell neu geschaffen"       endif  endif      // Fit mit einer Komponente  Make /O/N=1 W_coef  W_coef[0] = 1    FuncFit /G /Q /W=0 SingleSternVolmerPlot W_coef $YWave /X=$XWave /D  Rename  $FitWave, $Fit1Wave  Text = "\Z09\\K(0,0,65535)Ksv = " + num2str(W_coef[0]) + "  " + num2str(W_sigma[0]) + "\\K(0,0,0)"  // Erstes Nachfhren Logtabelle  variable AnzPte=numpnts(NameSVFit)  InsertPoints AnzPte,1, NameSVFit, P_KSV, E_KSV, P_F1,  E_F1, P_KSV1, E_KSV1, P_F2, E_F2, P_KSV2, E_KSV2, P_KSVG, E_KSVG, P_GW, E_GW, P_F0,  E_F0  NameSVFit[AnzPte] = YWave  P_KSV[AnzPte] = W_coef[0]  E_KSV[AnzPte] = W_sigma[0]  print "Einkomponentenfit", YWave, "ChisSq", V_chisq// Fit mit zwei Komponenten  Make /O/N=3 W_coef  W_coef[0] = 10  W_coef[1] = 0.5  W_coef[2] = 1  FuncFit /G /Q /W=0 DoubleSternVolmerPlot W_coef $YWave /X=$XWave /D  Rename $FitWave, $Fit2Wave  Text = Text + "\rf\B1\M\Z09 = " + num2str(W_coef[1]) + "  " + num2str(W_sigma[1])  Text = Text + "\rKsv\B1\M\Z09 = " + num2str(W_coef[0]) + "  " + num2str(W_sigma[0])  Text = Text + "\rf\B2\M\Z09 = " + num2str(1-W_coef[1]) + "  " + num2str(W_sigma[1])  Text = Text + "\rKsv\B2\M\Z09 = " + num2str(W_coef[2]) + "  " + num2str(W_sigma[2])    Textbox/B=1/F=0/S=3/A=MC Text  ModifyGraph rgb($Fit1Wave)=(0,0,65535), lstyle($Fit1Wave)=2  ModifyGraph rgb($Fit2Wave)=(0,0,0)    // Zweites Nachfhren Logtabelle  P_F1[AnzPte] = W_coef[1]  E_F1[AnzPte] = W_sigma[1]  P_KSV1[AnzPte] = W_coef[0]  E_KSV1[AnzPte] = W_sigma[0]  P_F2[AnzPte] = 1 - W_coef[1]  E_F2[AnzPte] = W_sigma[1]  P_KSV2[AnzPte] = W_coef[2]  E_KSV2[AnzPte] = W_sigma[2]  print "Zweikomponentenfit", YWave, "ChisSq", V_chisq  // Fitten mit Gaussverteilung  |  Make /O/N=3 W_coef|  W_coef[0] = 1;  W_coef[1] = 1;  W_coef[2] = 0|  FuncFit /H="001" /G /Q /W=0 NormalDistSternVolmerPlot W_coef $YWave /X=$XWave /D|  Rename $FitWave, $Fit3Wave|  if( !WinType("Verteilung_Ksv"))|	Verteilung_Ksv()|  else|	DoWindow/F Verteilung_Ksv|  endif|  P_KSVG[AnzPte] = W_coef[0]|  E_KSVG[AnzPte] = W_sigma[0]|  P_GW[AnzPte] = W_coef[1]|  E_GW[AnzPte] = W_sigma[1]|  P_F0[AnzPte] = W_coef[2]|  E_F0[AnzPte] = W_sigma[2]|  print "Normalverteilungsfit", YWave, "ChisSq", V_chisq  End| Darstellung des Stern-Volmer PlotsProc SternVolmerPlotStyle() : GraphStyle	PauseUpdate; Silent 1			ModifyGraph/Z gfSize=12	ModifyGraph/Z mode[0]=3	ModifyGraph/Z marker=8	ModifyGraph/Z rgb[0]=(0,0,0)	Label/Z left "I\\B0\\M/I"	Label/Z bottom "[O\\B2\\M] / bar"	SetAxis/Z/A/N=1 left	SetAxis/Z bottom 0,1	ModifyGraph width=142,height=142	ShowInfo	ShowToolsEndMacroWindow Verteilung_Ksv() : Graph	PauseUpdate; Silent 1		// building window...	Display /W=(550,194,956,437) f as "Verteilung Ksv"	ModifyGraph gfSize=12	Label left "f"	Label bottom "Ksv"	Legend/J/N=text0/F=0/S=3/A=MC/X=22.15/Y=12.66 "\\s(f) f"	Cursor A f 0.295879	ShowInfoEndMacro